----
-- upsidedown 17.09.2014

BioGasResiduesTool = {};

function BioGasResiduesTool:prerequisitesPresent(specializations)
    return true;
	--return SpecializationUtil.hasSpecialization(Sprayer, specializations);
end;

function BioGasResiduesTool:load(xmlFile)
	self.hasBiogasResiduesLoaded = false;
	self.hasBiogasResiduesLoadedSent = false;
	self.BGcounter = 10;
end;

-- function BioGasResiduesTool:postLoad(xmlFile)
	-- self.synchronizeFullFillLevel = true;
	-- self.synchronizeFillLevel = true;
	
-- end;
-- function BioGasResiduesTool:writeUpdateStream(streamId, connection)  
	-- streamWriteBool(streamId, self.hasBiogasResiduesLoaded);
-- end;
-- function BioGasResiduesTool:readUpdateStream(streamId, connection)  
	-- self.hasBiogasResiduesLoaded = streamReadBool(streamId);
-- end;

function BioGasResiduesTool:writeStream(streamId, connection)  
	streamWriteBool(streamId, self.hasBiogasResiduesLoaded);
end

function BioGasResiduesTool:readStream(streamId, connection)  
	self.hasBiogasResiduesLoaded = streamReadBool(streamId);
end

function BioGasResiduesTool:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BioGasResiduesTool:keyEvent(unicode, sym, modifier, isDown)
end;

function BioGasResiduesTool:updateTick(dt)
	if self.isServer then
		if self.currentFillType ~= Fillable.FILLTYPE_LIQUIDMANURE then --e.g. empty, water or simply no lm-vehicle
			self.hasBiogasResiduesLoaded = false;		
		else
		
			-- print("isFilling: "..tostring(self.isFilling))
		
			self.BGcounter = self.BGcounter - 1;
			if self.BGcounter < 0 then
				if self.fillLevel >= self.capacity then
					-- if self.capacity - math.floor(self.capacity) < 0.0001 then
						-- self.capacity = self.capacity +  0.0001;
					-- end;
					-- -- -- self.fillLevel = self.capacity - 0.00001;
					self:setFillLevel(self.capacity - 1.1,Fillable.FILLTYPE_LIQUIDMANURE);					
				end;
				self.BGcounter = 100; --just check this from time to time to stop filling, but be never so full that residue triggers are not contacted anymore
			end;
			
			if self.fillTriggers ~= nil then
				if self.isFilling then
					for _,trigger in pairs(self.fillTriggers) do
						if trigger.fillType == Fillable.FILLTYPE_LIQUIDMANURE and trigger.isEnabled then
							if trigger.parent~= nil then
								-- for key,value in pairs(trigger.parent) do
									-- print(tostring(key).."  "..tostring(value))
								-- end;
								-- print("================")
								if trigger.parent.hasBiogasResiduesLoaded then
									self.hasBiogasResiduesLoaded = true;
								end;
							end;
						end;
					end;
				end;
			end;		
		end;
		
		if self.hasBiogasResiduesLoaded then
			if self.isOverloadingActive then
				if self.overloadingTrailersInRange ~= nil then
					for key,value in pairs(self.overloadingTrailersInRange) do
						key.hasBiogasResiduesLoaded = true;
					end;
				end;
			end;
		end;
		
		if self.hasBiogasResiduesLoadedSent ~= self.hasBiogasResiduesLoaded then
			--call server2clients event
			ResidueSyncEvent.sendEvent(self);
			self.hasBiogasResiduesLoadedSent = self.hasBiogasResiduesLoaded;
		end;
				
	end;
end;


function BioGasResiduesTool:update(dt)
	
end;

function BioGasResiduesTool:draw()
	if self.hasBiogasResiduesLoaded then
		g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_BioGasResiduesTool") )
	end;
end;

function BioGasResiduesTool:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
  local hasloaded = getXMLBool(xmlFile, key .. "#hasBiogasResiduesLoaded");
  self.hasBiogasResiduesLoaded = Utils.getNoNil(hasloaded,false);

  return BaseMission.VEHICLE_LOAD_OK
end

function BioGasResiduesTool:getSaveAttributesAndNodes(nodeIdent)
 
  local attributes = "hasBiogasResiduesLoaded=\"" .. tostring(self.hasBiogasResiduesLoaded) .. "\""
  return attributes, nil
end


function BioGasResiduesTool:delete()	
end

ResidueSyncEvent = {};
ResidueSyncEvent_mt = Class(ResidueSyncEvent, Event);

InitEventClass(ResidueSyncEvent, "ResidueSyncEvent");

function ResidueSyncEvent:emptyNew()
    local self = Event:new(ResidueSyncEvent_mt);
    self.className="ResidueSyncEvent";
    return self;
end;

function ResidueSyncEvent:new(sprayer)
    local self = ResidueSyncEvent:emptyNew()
    self.sprayer = sprayer;
	self.hasBiogasResiduesLoaded = sprayer.hasBiogasResiduesLoaded;	
	
    return self;
end;

function ResidueSyncEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.sprayer));
	streamWriteBool(streamId, self.hasBiogasResiduesLoaded);
	
	--print("server side event is sending stuff")
end;

function ResidueSyncEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.sprayer = networkGetObject(id);
	
	self.sprayer.hasBiogasResiduesLoaded = streamReadBool(streamId);		
end;

function ResidueSyncEvent.sendEvent(sprayer)
	if g_server ~= nil then
		g_server:broadcastEvent(ResidueSyncEvent:new(sprayer), nil, nil, sprayer);	
	end;
end;